package compiler;

/**
 * Reprsentiert eine Fehlermeldung eines Compilers
 * 
 * @author Dietrich Boles, Uni Oldenburg
 * @version 1.0 (12.11.2008)
 * 
 */
public class ErrorMessage {
	private String filename;
	private String msg;

	/**
	 * Erzeugt eine Fehlermeldung; bergeben wird der Dateiname und die Meldung
	 * 
	 * @param filename
	 * @param msg
	 */
	public ErrorMessage(String filename, String msg) {
		this.filename = filename;
		this.msg = msg;
	}

	/**
	 * Erzeugt eine (nicht initialisierte) Fehlermeldung
	 */
	public ErrorMessage() {
		this.filename = null;
		this.msg = null;
	}

	/**
	 * Liefert den Dateinamen
	 * 
	 * @return
	 */
	public String getFilename() {
		return filename;
	}

	/**
	 * Setzt den Dateinamen
	 * 
	 * @param filename
	 */
	/**
	 * @param filename
	 */
	public void setFilename(String filename) {
		this.filename = filename;
	}

	/**
	 * Liefert die Meldung
	 * 
	 * @return
	 */
	public String getMsg() {
		return msg;
	}

	/**
	 * Setzt die Meldung
	 * 
	 * @param msg
	 */
	public void setMsg(String msg) {
		this.msg = msg;
	}

}
