package listener;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import model.Play;
import util.IO;
import util.ResourceManager;
import view.JImageChooser;

/**
 * Listener zum Auswhlen eines Bildes
 * 
 * @author Dietrich Boles, Uni Oldenburg
 * @version 1.0 (12.11.2008)
 * 
 */
public class LoadImageListener implements ActionListener {

	static JImageChooser chooser = new JImageChooser();

	public void actionPerformed(ActionEvent e) {
		LoadImageListener.loadImage();
	}

	/**
	 * Ldt ein Bild und speichert es im Theaterstck-Unterverzeichnis "images"
	 * ab
	 */
	public static void loadImage() {
		int returnVal = LoadImageListener.chooser.showDialog(Play.getPlay()
				.getPlayFrame(), ResourceManager.getResourceManager().getValue(
				"import"));
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File fromFile = LoadImageListener.chooser.getSelectedFile();
			File dir = new File(Play.getPlay().getDirectory());
			File toFile = new File(dir.getAbsolutePath() + File.separatorChar
					+ "images" + File.separatorChar + fromFile.getName());
			if (IO.copyMediaFile(fromFile, toFile)) {
				Play.getPlay().getPlayFrame().getMessagePanel().writeInfo(
						ResourceManager.getResourceManager().getValue(
								"msg.filecopysuccessfull"));
			} else {
				JOptionPane.showMessageDialog(Play.getPlay().getPlayFrame(),
						ResourceManager.getResourceManager().getValue(
								"msg.filecopynotsuccessfull"), ResourceManager
								.getResourceManager().getValue("msg.error"),
						JOptionPane.ERROR_MESSAGE);
			}
		}
	}
}
