package simulation;

import simulation.listener.EventObject;
import theater.Actor;
import theater_intern.IStage;

public abstract class SimulationManager {

	private static SimulationManager simManager = null;

	public static SimulationManager getSimulationManager() {
		return simManager;
	}

	public static void setSimulationManager(SimulationManager man) {
		simManager = man;
	}
	
	public abstract void reset();
	
	public abstract void setDisabled();

	public abstract void handleStart();

	public abstract void handleStop();

	public abstract void handleSuspend();

	public abstract void handleResume();

	public abstract void handleAPIStop();

	public abstract void handleAPISuspend();
	
	public abstract void handleStageChange(IStage stage);
	
	public abstract void addActor(Actor actor);
	
	public abstract void removeActor(Actor actor);

	public abstract void newEventObject(EventObject obj);
	
	public abstract void processEventObjects();

}
