package theater;

/**
 * Die Klasse Actor ist die Basisklasse aller Akteure. Sie erbt als Unterklasse
 * der Klasse Component, die wiederum Unterklasse der Java-Klasse Thread ist,
 * alle Methoden dieser beiden Klassen.
 * <p>
 * </p>
 * Soll ein neuer Akteur definiert werden, muss eine entsprechende Klasse von
 * der Klasse Actor abgeleitet und die Methode "public void run()" berschrieben
 * werden. In dieser wird das Eigenleben von Akteuren der Klasse festgelegt,
 * wobei u. a. die geerbten Methoden der Klassen Component und Thread genutzt
 * werden knnen.
 * 
 * @author Dietrich Boles, Universitt Oldenburg, Germany
 * @version 1.0 (12.11.2008)
 * 
 */
public class Actor extends Component {

	/**
	 * Default-Konstruktor der Klasse Actor
	 */
	public Actor() {
		super(true);
	}

	/**
	 * Muss berschrieben werden und die Actor-spezifischen Aktionen enthalten
	 */
	public void run() {
	}


}
