import theater.Actor;
import theater.Performance;

import java.util.concurrent.locks.ReentrantLock;


public class Philosoph extends Actor {
    private static ReentrantLock lock = new ReentrantLock();
    private Gabel linkeGabel;
    private Gabel rechteGabel;

    Philosoph(Gabel linkeGabel, Gabel rechteGabel) {
        this.setImage("Denker.gif");
        this.linkeGabel = linkeGabel;
        this.rechteGabel = rechteGabel;
    }

    public void run() {
        while (true) {
            this.denken();
            this.nimmGabeln();
            this.essen();
            this.gibGabeln();
        }
    }

    private void nimmGabeln() {
        if (this.linkeGabel.istVergoldet()) {
            this.nimmRechteGabel();
            changeImages(this, "PhiloMitRechterGabel.gif", this.rechteGabel,
                "KeineGabel.gif");
            this.nimmLinkeGabel();
            changeImages(this, "Esser.gif", this.linkeGabel, "KeineGabel.gif");
        } else {
            this.nimmLinkeGabel();
            changeImages(this, "PhiloMitLinkerGabel.gif", this.linkeGabel,
                "KeineGabel.gif");
            this.nimmRechteGabel();
            changeImages(this, "Esser.gif", this.rechteGabel, "KeineGabel.gif");
        }
    }

    private void nimmLinkeGabel() {
        this.linkeGabel.aufnehmen(this);
    }

    private void nimmRechteGabel() {
        this.rechteGabel.aufnehmen(this);
    }

    private void gibGabeln() {
        lock.lock();
        this.gibLinkeGabel();
        changeImages(this, "PhiloMitRechterGabel.gif", this.linkeGabel,
            this.linkeGabel.istVergoldet() ? "GoldGabel.gif" : "Gabel.gif");
        lock.unlock();
        lock.lock();
        this.gibRechteGabel();
        changeImages(this, "Denker.gif", this.rechteGabel,
            this.rechteGabel.istVergoldet() ? "GoldGabel.gif" : "Gabel.gif");

        lock.unlock();
    }

    private void gibLinkeGabel() {
        this.linkeGabel.ablegen();
    }

    private void gibRechteGabel() {
        this.rechteGabel.ablegen();
    }

    private void denken() {
        int bedenkZeit = (int) (Math.random() * 5000);

        try {
            Thread.sleep(bedenkZeit);
        } catch (Exception exc) {
        }
    }

    private void essen() {
        Performance.getPerformance().playSound("Ruelpser.wav");
        int kauZeit = (int) (Math.random() * 3000);

        try {
            Thread.sleep(kauZeit);
        } catch (Exception exc) {
        }
    }

    private void changeImages(Philosoph p, String pImg, Gabel g, String gImg) {
        lock.lock();
        p.setImage(pImg);
        g.setImage(gImg);
        lock.unlock();
    }
}
