import theater.*;

import java.awt.event.MouseEvent;

import java.util.List;


public class Raumschiff extends Actor {
    public Raumschiff() {
        // Icon zuordnen 
        setImage("raumschiff.gif");
    }

    public void run() {
        // Raumschiff gleitet im Weltraum hin und her
        int step = 1; // Richtung Ost

        while (true) {
            // befindet sich das Icon vollstaendig auf der Buehne?
            if (!isInside(getStage())) {
                step *= -1; // Richtunsgwechsel
                getImage().mirrorHorizontally(); // Icon-Spiegelung
            }

            // eine Celle in der aktuellen Richtung weiter platzieren
            setLocation(getColumn() + step, getRow());
            ueberpruefeFelsKollision();
        }
    }

    private void ueberpruefeFelsKollision() {
        synchronized (Fels.class) {
            List<Component> felsen = getStage()
                                         .getIntersectingComponents(this,
                    Fels.class);

            for (Component fels : felsen) {
                getStage().remove(fels); // Fels wegbeamen
            }
        }
    }

    public void mousePressed(MouseInfo event) {
        // Veraenderung der Thread-Prioritaet bei Mausklick auf Icon
        event.consume();

        if (event.getButton() == MouseEvent.BUTTON1) {
            setPriority(Math.min(getPriority() + 1, Thread.MAX_PRIORITY));
        } else {
            setPriority(Math.max(getPriority() - 1, Thread.MIN_PRIORITY));
        }
    }
}
